
#ifndef _THREAD_MAP_POLKA_H_
#define _THREAD_MAP_POLKA_H_

#include "tuxian.H"
#include "palette.H"
#include <polka.H>

class ThreadMap_polka: public ThreadMap {
  private:
    ResizeMode  resize_mode;
    int		global_time;
    int  	num_threads_in_unit_window;	// num thrds/1.0 height
    int 	max_num_threads;
    Text	**name_texts;			// array of Text obj of name
    double 	xsequ, xthrdid, xprocno, xforkts, xexitts, xclr, xname;
    double 	origy, yincr, thickness;
    Palette  	*color_depot;			// color names
    char 	*fontname;
    
protected:
    View *polkaview;			// polka view
    void threadmapInitialize();
    void threadmapNewThread(int, unsigned long, unsigned long, int, char*);
    void threadmapNewName(int, char*);
    void threadmapThreadExit(int, unsigned long, unsigned long);
    void threadmapVScroll(int);
    
public:
    ThreadMap_polka(int threads_in_win = 16,
		    int resize_const = False,
		    int number_of_colors = 0,
		    char **names_of_colors = NULL);
    ~ThreadMap_polka() {
	delete(polkaview);
	delete(color_depot);
    }
    void draw() {
	global_time = polkaview->FastAnimate(global_time, 1); }
};

#endif
