

#ifndef __REORDER_INTERF_H__
#define __REORDER_INTERF_H__

#if defined(FUNCPROTO) || __STDC__ || defined(__cplusplus) || defined(c_plusplus)
#ifndef ARGS
#define ARGS(args) args
#endif
#endif

#ifndef False
#define False 0
#endif

#ifndef True
#define True (!False)
#endif

#define DBG1(f,a)	{if (de_debug_flag) fprintf(stderr,f,a);}
#define DBG2(f,a,b)	{if (de_debug_flag) fprintf(stderr,f,a,b);}
#define DBG3(f,a,b,c)	{if (de_debug_flag) fprintf(stderr,f,a,b,c);}
#define DBG4(f,a,b,c,d)	{if (de_debug_flag) fprintf(stderr,f,a,b,c,d);}
#define DBG5(f,a,b,c,d,e) {if (de_debug_flag) fprintf(stderr,f,a,b,c,d,e);}


/* The following items should be editted to your display.
 * NUMBER_OF_SENSORS is number of trace events you use in your display or
 * trace analyzer. Each event should give a number from 0 to
 * NUMBER_OF_SENSORS - 1.  */

#define NUMBER_OF_SENSORS	30

/* default sensor numbers */
#define DM_THREAD_INIT          0
#define DM_THREAD_FORK		1
#define DM_THREAD_EXIT		2
#define DM_THREAD_BEGIN_JOIN  	3
#define DM_THREAD_END_JOIN	4
#define DM_THREAD_DETACH	5
#define DM_THREAD_YIELD		6
#define DM_THREAD_SET_NAME	7
#define DM_MUTEX_BEGIN_LOCK	8
#define DM_MUTEX_END_LOCK	9
#define DM_MUTEX_UNLOCK  	10
#define DM_MUTEX_ALLOC 		11
#define DM_MUTEX_INIT  		12
#define DM_MUTEX_FREE	  	13
#define DM_MUTEX_CLEAR	  	14
#define DM_MUTEX_SET_NAME	15
#define DM_CONDITION_ALLOC 	16
#define DM_CONDITION_INIT 	17
#define DM_CONDITION_FREE 	18
#define DM_CONDITION_CLEAR 	19
#define DM_CONDITION_BEGIN_WAIT 20
#define DM_CONDITION_END_WAIT   21
#define DM_CONDITION_BROADCAST 	22
#define DM_CONDITION_SIGNAL 	23
#define DM_CONDITION_SET_NAME	24
#define DM_THREAD_OFF_RUNQ      25
#define DM_PROCESSOR_BEGIN_IDLE 26
#define DM_PROCESSOR_END_IDLE   27
#define DM_PROGRAM_EXIT		28
#define DM_MONITOR_EXIT		29

typedef struct _buffer_record {
    struct _buffer_record *Next;
    DESavedRecPtr rec;
} buffer_record, *buffer_recordPtr;

extern int CMonInterfInit ARGS((int *, char **));
extern int format_ids[];

typedef struct _var_data {
    int size;
    char data[1];
} var_data;

typedef var_data *mutex_T;
typedef var_data *condition_t;
typedef var_data *thread_T;
typedef long seq_num;

extern int same_size ARGS((var_data * p1, var_data * p2));
extern int equal ARGS((var_data * p1, var_data * p2));

extern thread_T get_child_thread ARGS((buffer_recordPtr rec));

extern long get_type ARGS((buffer_recordPtr rec));

extern mutex_T get_mutex ARGS((buffer_recordPtr rec));

extern thread_T get_join_to ARGS((buffer_recordPtr rec));

extern seq_num get_seq_num ARGS((buffer_recordPtr rec));

extern thread_T get_thread ARGS((buffer_recordPtr rec));

extern seq_num get_begin_seq_num ARGS((buffer_recordPtr rec));

extern seq_num get_end_seq_num ARGS((buffer_recordPtr rec));

extern condition_t get_condition ARGS((buffer_recordPtr rec));
#endif
