

#ifndef _SENSOR_H_
#define _SENSOR_H_

#define MAX_BASIC_TYPE   20

#define EVENT_SENSOR     1
#define STATE_SENSOR     2
#define SAMPLE_SENSOR	 3

#ifdef False
#undef False
#endif

#ifdef True
#undef True
#endif

#define False   0
#define True    1

#if defined(FUNCPROTO) || __STDC__ || defined(__cplusplus) || defined(c_plusplus)
#ifndef ARGS
#define ARGS(args) args
#endif
#ifndef	NULL
/*
 * NULL --
 *	Null pointer.
 */
#define NULL	((void *) 0)
#endif
#else
#ifndef ARGS
#define ARGS(args) (/*args*/)
#endif
#ifndef	NULL
/*
 * NULL --
 *	Null pointer.
 */
#define NULL	0
#endif
#endif

/* unix system calls */

extern void* malloc();
#ifndef FPRINTF_DEFINED
extern int fprintf ARGS((FILE *, const char *, ...));
#endif
#ifndef FSCANF_DEFINED
extern int fscanf ARGS((FILE *, const char *, ...));
#endif
#ifndef toupper
extern int toupper ARGS((int c));
#endif
extern void free();
extern int system();
#ifndef strdup
extern char *strdup();
#endif
extern int   fclose();

typedef struct _NumberList {
    int			number;
    struct _NumberList  *next, *prev;
} NumberList, *NumberListP;

#define NumberListInit(numlist, num) \
{ \
    (numlist) = (NumberListP) malloc(sizeof(NumberList)); \
    (numlist)->number = (num); \
    (numlist)->prev = (numlist)->next = NULL; \
}


#define StringInit(str, orig) \
{ \
        (str) = (char*) malloc(strlen(orig)+1); \
	strcpy((str), (orig)); \
}


typedef enum {
    CHAR_TYPE, SHORT_TYPE, INT_TYPE, LONG_TYPE,
    UCHAR_TYPE, USHORT_TYPE, UINT_TYPE, ULONG_TYPE,
    FLOAT_TYPE, DOUBLE_TYPE, STRING_TYPE,
  } AttributeType;


typedef enum {
    USER_SPECIFY_LOCATION, DEFAULT_LOCATION,
    BEFORE_PROC_CALL_LOCATION, AFTER_PROC_CALL_LOCATION,
    BEGINNING_PROC_LOCATION, END_PROC_LOCATION,
    BEFORE_SEND_LOCATION, AFTER_SEND_LOCATION,
    BEFORE_RECEIVE_LOCATION, AFTER_RECEIVE_LOCATION,
    BEFORE_SH_ACCESS_LOCATION, AFTER_SH_ACCESS_LOCATION,
    AT_LINES_LOCATION
  } LocationType;


typedef enum {
    DEFAULT_POLICY
  } PolicyType;


typedef struct _Policy {
    PolicyType		type;
    struct _Policy	*next, *prev;
} Policy, *PolicyP;

#define PolicyInit(pol, polType) \
{ \
    (pol) = (PolicyP) malloc(sizeof(Policy)); \
    (pol)->type = (polType); \
    (pol)->prev = (pol)->next = NULL; \
}


typedef struct _Location {
    LocationType	type;
    char		*name;
    int 		*lines;
    struct _Location	*next, *prev;
} Location, *LocationP;


typedef struct _Attribute {
    char 		*name;
    AttributeType  	type;
    int                 arraySize;
    char		*expression;
    struct _Attribute   *next, *prev;
} Attribute, *AttributeP;


typedef struct _Sensor {
    int 	sensorType, numAttributes, numSampAttributes;
    int		numLocations, numPolicies;
    char  	*name;
    AttributeP 	attributes, samp_attrs;
    LocationP  	locations;
    PolicyP	policies;
    struct  _Sensor *next, *prev;
    int		have_array_fld;
}Sensor, *SensorP;

#endif

